/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_BIT_REGISTER__
#define __DD_BIT_REGISTER__

#include "DDBitList.h"

#define INITIAL_REGISTER_WIDTH 1

namespace double_description {
	
	class BitRegister : public BitList {

		public:
		BitRegister ();
		BitRegister ( const unsigned long blocks );
		~BitRegister () {}

		void resize ( const unsigned long blocks );

		void getFirstCommonBit ( const BitList & map, unsigned long & block, unsigned long & position ) const {

			for ( block = 0; block < getBlocks(); block++ ) {
				unsigned long block_data = getData( block ) & map[block];

				if ( block_data ) {
					position = __builtin_ctzl( block_data );
					break; 
				}
			}
		}

		unsigned long getOpAND ( const unsigned long & block, const unsigned long & blockData ) const {
			return getData( block ) & blockData;
		}
	};
}

#endif // __DD_BIT_REGISTER__
