
#ifndef __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__
#define __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__

#include "DDPreliminaryCondition.h"

namespace double_description {

	class DoubleVantagePointPreliminaryCondition : public VantagePointPreliminaryCondition {

        protected:
        const unsigned short mMinInvDistance;

		public:
		DoubleVantagePointPreliminaryCondition ( const BitList & map,
										         const unsigned int minCommonBits,
										         const BitList & point,
                                                 const unsigned short distance,
                                                 const unsigned short inverse ) :
            MapCondition( map ),
			VantagePointPreliminaryCondition( map, minCommonBits, point, distance ),
            mMinInvDistance( inverse ) {}

        bool holdsOnFace ( const BitList & activeSetUnion ) const {
            const unsigned short union_dist = mVantagePoint.getCommonPopCnt( activeSetUnion ) + 1;
            const unsigned short union_inv_dist = mVantagePoint.getInvCommonPopCnt( activeSetUnion ) + 1;
            return std::min( union_dist, mMinDistance ) + std::min( union_inv_dist, mMinInvDistance ) >= getMinCommonBits() + 2;
        }

        const std::string toString () const {
            std::stringstream result;

            result << "~d=" << mMinInvDistance;

            return VantagePointPreliminaryCondition::toString() + ", " + result.str();            
        }
	};
}

#endif // __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__
