/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_EXT_VERIFICATION_CONDITION__
#define __DD_EXT_VERIFICATION_CONDITION__

#include "DDBitList.h"
#include "DDVerificationCondition.h"

namespace double_description {

	class ExtVerificationCondition : virtual public VerificationCondition {

		protected:
		const BitList & mIllegalCandidate_1;
        const BitList & mIllegalCandidate_2;

		public:
		ExtVerificationCondition ( const BitList & faceActiveSet,
								   const BitList & illegal_1,
                                   const BitList & illegal_2 ) :
            MapCondition( faceActiveSet ),
			VerificationCondition( faceActiveSet ),
			mIllegalCandidate_1( illegal_1 ),
            mIllegalCandidate_2( illegal_2 ) {}

		bool holdsOnRay ( const BitList & activeSet ) const {
			return VerificationCondition::holdsOnRay( activeSet ) &&
                    activeSet != mIllegalCandidate_1 && 
                    activeSet != mIllegalCandidate_2;
		}
	};
}

#endif // __DD_EXT_VERIFICATION_CONDITION__
