
#ifndef __DD_INTERMEDIATE_HYBRID_TREE_NODE__
#define __DD_INTERMEDIATE_HYBRID_TREE_NODE__

#include "DDLogging.h"

#include "DDBitList.h"

#include "DDTreeNode.h"
#include "DDPopTreeLeafNode.h"
#include "DDIntermediatePopulationNode.h"
#include "DDIntermediatePopToBitSetNode.h"

#include "DDSamplesContainer.h"
#include "DDHybridTreeCreatorUtils.h"

namespace double_description {

	class IntermediateHybridTreeNode : public IntermediatePopulationNode {

		protected:
		PopTreeNode * createChildNode ( const std::vector<struct RayReference> & candidates,
									    const BitList & map,
								        const BitList & regPattern,
										const BitList & invPattern,
                                        const unsigned short degeneracy,
										PopTreeCreatorUtils & utils,
										const unsigned int sampleID ) const;

		public:
		IntermediateHybridTreeNode ( const BitList & map,
                                        const PreliminaryCondition * const cond,
										const unsigned int samplesCount ) :
			TreeNode( map, cond, USHRT_MAX ),
			IntermediatePopulationNode( map, cond, samplesCount ) {}

		IntermediateHybridTreeNode ( const BitList & map,
                                     const PreliminaryCondition * const cond,
									 const BitList & regPattern,
									 const BitList & invPattern,
                                     const unsigned short degeneracy ) :
			TreeNode( map, cond, degeneracy ),
			IntermediatePopulationNode( map, cond, regPattern, invPattern, degeneracy ) {}

		virtual ~IntermediateHybridTreeNode() {}
	};
}

#endif // __DD_INTERMEDIATE_POP_TO_BIT_SET_NODE__
