
#include "DDIntermediatePopToBitSetNode.h"
#include "DDPopTreePreliminaryCondition.h"
#include "DDPopTreeLeafNode.h"

#include "DDMostCommonBitFirstStrategy.h"
#include "DDLeastCommonBitFirstStrategy.h"
#include "DDMostAverageBitFirstStrategy.h"

using namespace double_description;

TreeNode * IntermediatePopToBitSetNode::createChildNode ( const std::vector<struct RayReference> & candidates,
						    					          const BitList & map,
                                                          const unsigned short degeneracy,
                                                          BitSetTreeCreatorUtils & utils ) const {

 /*   TreeNode * result;
    const PreliminaryCondition * cond = new PopTreePreliminaryCondition( map, mCond->getMinCommonBits(), mRegPattern, mInvPattern );

	if ( candidates.size() < utils.getMaxElementsPerLeaf() || utils.selector().checkNextBit( map ) ) {
        const unsigned long pop_coeff = utils.selector().getPopulationCoeff( map );
		result = new PopTreeLeafNode( candidates, map, cond, pop_coeff, mRegPattern, mInvPattern );
	} else {
        IntermediatePopToBitSetNode * node = new IntermediatePopToBitSetNode( map, cond, mRegPattern, mInvPattern );
        node->partition( candidates, utils );
		result = node;
	}    

    return result; */


    TreeNode * result;
    const PreliminaryCondition * cond = new PreliminaryCondition( map, mCond->getMinCommonBits() ); 

	if ( candidates.size() < utils.getMaxElementsPerLeaf() || !utils.selector().checkNextBit( map ) ) {
		result = new LeafNode( candidates, map, cond, degeneracy );
	} else {
    /*    BitSelector selector( MostAverageBitFirstStrategy ( candidates, utils.getTotalPlanes() ));
        BitSetTreeCreatorUtils opt_utils( utils.getMaxElementsPerLeaf(), selector, utils.getTotalPlanes() ); */
        IntermediateBitSetNode * node = new IntermediateBitSetNode( map, cond, degeneracy );
        node->partition( candidates, utils );
		result = node;
	}    

    return result;
}

bool IntermediatePopToBitSetNode::verificationTraverse ( const VerificationCondition & condition ) const {

	if ( condition.holdsOnFace( mMap, mRegPattern, mInvPattern ) ) {
		return mSuperSet->verificationTraverse( condition ) || 
				 mSubSet->verificationTraverse( condition );
	} else {
		return false;
	}			
}
