
#ifndef __DD_LEAST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__
#define __DD_LEAST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__

#include <vector>
#include <algorithm>

#include "DDDynamicSampleCreator.h"

namespace double_description {

    struct LeastCommonFirstComparator {

        bool operator () ( const struct PopulationEntry & lhs, const struct PopulationEntry & rhs ) const {
            return lhs.count < rhs.count;
        }
    };

    class LeastCommonFirstDynamicSampleCreator : public DynamicSampleCreator {
    
        public:
        LeastCommonFirstDynamicSampleCreator( const unsigned short blocks,
                                              const unsigned short minCommonBits,
                                              const float intensityFactor,
                                              const float sampleDifference,
                                              const float stretch ) :
            DynamicSampleCreator( blocks, minCommonBits, intensityFactor, sampleDifference, stretch ) {}   

            void reorder ( std::vector<struct PopulationEntry> & stats ) const {
                struct LeastCommonFirstComparator comparator;
                sort( stats.begin(), stats.end(), comparator );
            }
    };
}

#endif // __DD_LEAST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__
