/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_MOST_COMMON_BIT_FIRST_STRATEGY__
#define __DD_MOST_COMMON_BIT_FIRST_STRATEGY__

#include <vector>

#include "DDCommonBitStrategy.h"

namespace double_description {

    class MostCommonBitFirstStrategy : public CommonBitStrategy {
        
        public:
        MostCommonBitFirstStrategy ( const RayReferenceContainer & entries,
                                     const unsigned int plane ) :
            CommonBitStrategy( entries, plane ) {}     

        MostCommonBitFirstStrategy ( const std::deque<EdgeCandidate> & entries,
                                     const unsigned int plane ) :
            CommonBitStrategy( entries, plane ) {}   

            unsigned long getTargetValue( const std::vector<unsigned long> & population ) const {
                unsigned long max = 0;

                for ( unsigned long index = 0; index < population.size(); index++ ) {
                    if ( population[index] > max ) {
                        max = population[index];
                    }
                }

                return max;
            }
    };
}

#endif // __DD_MOST_COMMON_BIT_FIRST_STRATEGY__
