
#ifndef __DD_PATTERN_GRAPH__
#define __DD_PATTERN_GRAPH__

#include "DDBitList.h"
#include "DDLogging.h"

namespace double_description {

	class PatternGraph {
		
		private:
		unsigned short ** mMap;
		unsigned short * mCount;

		unsigned short * mNodes;
		unsigned long mNodeCount;

#if defined _LP64 || defined __LP64__
		unsigned long fac ( const unsigned char n ) const;
#else
		unsigned long long fac ( const unsigned char n ) const;
#endif // _LP64 || defined __LP64__

		unsigned short getNodeCount ( const unsigned short depth, const unsigned short threshold ) const;
		
		public:
		PatternGraph ( const unsigned short depth, const unsigned short threshold );
		~PatternGraph ();

		unsigned short getEdgesCount ( const unsigned short src ) const {
			return mCount[src];
		}

		const unsigned short * getEdges ( const unsigned short src ) const {
			return mMap[src];
		}

		const unsigned short * getNodes () const {
			return mNodes;
		}

		unsigned short getNodesCount () const {
			return mNodeCount;
		}
	};
}

#endif // __DD_PATTERN_GRAPH__
