
#ifndef __DD_POP_TREE_PRELIMINARY_CONDITION__
#define __DD_POP_TREE_PRELIMINARY_CONDITION__

#include "DDBitList.h"
#include "DDMapCondition.h"
#include "DDPopTreeMapCondition.h"
#include "DDPreliminaryCondition.h"

namespace double_description {

	class PopTreePreliminaryCondition : public PreliminaryCondition, public PopTreeMapCondition {

		public:
		PopTreePreliminaryCondition ( const BitList & map,
										const unsigned int minCommonBits,
										const BitList & regPattern,
										const BitList & invPattern ) :
            MapCondition( map ),
			PreliminaryCondition( map, minCommonBits ),
			PopTreeMapCondition( map, regPattern, invPattern ) {}

        bool holdsOnRay( const BitList & activeSet ) const {
            return PreliminaryCondition::holdsOnRay( activeSet );
        }

        bool holdsOnFace ( const BitList & activeSetUnion ) const {
            return PreliminaryCondition::holdsOnFace( activeSetUnion );
        }

		bool holdsOnFace ( const BitList & activeSetUnion, const BitList & faceRegPattern, const BitList & faceInvPattern ) const {

			return PreliminaryCondition::holdsOnFace( activeSetUnion ) &&
					( faceRegPattern & mRegPattern ).isUnionFull( faceInvPattern & mInvPattern );
		}
	};
}

#endif // __DD_POP_TREE_PRELIMINARY_CONDITION__
