
#ifndef __DD_POP_TREE_VERIFICATION_CONDITION__
#define __DD_POP_TREE_VERIFICATION_CONDITION__

#include "DDBitList.h"
#include "DDPopTreeMapCondition.h"
#include "DDVerificationCondition.h"

namespace double_description {

	class PopTreeVerificationCondition : virtual public VerificationCondition, public PopTreeMapCondition {

		public:
		PopTreeVerificationCondition ( const BitList & faceActiveSet, const BitList & regPattern, const BitList & invPattern ) :
            MapCondition( faceActiveSet ),
			VerificationCondition( faceActiveSet ),
			PopTreeMapCondition( faceActiveSet, regPattern, invPattern ) {}

		bool holdsOnFace ( const BitList & activeSetUnion, const BitList & faceRegPattern, const BitList & faceInvPattern ) const {

			return VerificationCondition::holdsOnFace( activeSetUnion ) &&
					faceRegPattern.contains( PopTreeMapCondition::mRegPattern ) &&
                    faceInvPattern.contains( PopTreeMapCondition::mInvPattern ); 
		}
	};
}

#endif // __DD_POP_TREE_VERIFICATION_CONDITION__
