
#ifndef __DD_REGULAR_STATIC_SAMPLE_CREATOR__
#define __DD_REGULAR_STATIC_SAMPLE_CREATOR__

#include "DDStaticSampleCreator.h"

namespace double_description {

    class RegularStaticSampleCreator : public StaticSampleCreator {

        protected:
        const std::vector<unsigned long> getBasicSamples () const {
            const unsigned long samples[] = { 0x5555555555555555,
		                                      0x9999999999999999,
		                                      0xF0F0F0F0F0F0F0F0,
		                                      0x3333333333333333, 
		                                      0xC3C3C3C3C3C3C3C3,
		                                      0x6969696969696969,
		                                      0xA5A5A5A5A5A5A5A5,
		                                      0x0000FFFF0000FFFF,
		                                      0x00FF00FF00FF00FF,
		                                      0xD2D2D2D2D2D2D2D2,
		                                      0xE5E5E5E5E5E5E5E5,
		                                      0xC9C9C9C9C9C9C9C9 };
            std::vector<unsigned long> result( 12 );
            result.assign( samples, samples + 12 );

            return result;
        }

        public:
        RegularStaticSampleCreator ( const unsigned short blocks,
                              const unsigned short minCommonBits,
                              const float limit ) :
            StaticSampleCreator( blocks, minCommonBits, limit ) {}
    };
}

#endif // __DD_REGULAR_STATIC_SAMPLE_CREATOR__
