/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_SINGLE_SET_RAY_GENERATOR__
#define __DD_SINGLE_SET_RAY_GENERATOR__

#include "DDExtremeRayGenerator.h"

#include "DDMatrix.h"
#include "DDRayCache.h"
#include "DDSingleSetRay.h"

#include "DDExtremeRayUncompressor.h"
#include "DDBitPatternTreeCacheEntry.h"

namespace double_description {

	class SingleSetRayGenerator : public ExtremeRayGenerator<SingleSetRay> {

        protected:
		const struct StepStats enumerate ( const unsigned long plane, BitPatternTreeCacheEntry<SingleSetRay> & cache_entry );

		public:
#ifdef __COMPRESSION__
		SingleSetRayGenerator ( const Matrix & original, const Matrix & system, const Matrix& transformator ) :
            ExtremeRayGenerator( original, system, transformator ) {}
#else
		SingleSetRayGenerator ( const Matrix& system, const Matrix& transformator ) :
            ExtremeRayGenerator( system, transformator ) {}
#endif
        
        void calculateBase ();
	};
}

#endif // __DD_SINGLE_SET_RAY_GENERATOR_
