/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_SORT_CRITERIA__
#define __DD_SORT_CRITERIA__

#include "DDCalculationVector.h"

namespace double_description {

	class SortCriteria {

		public:
		virtual int cmp ( const CalculationVector & lhs, const CalculationVector & rhs ) const = 0;

		bool gt ( const CalculationVector & lhs, const CalculationVector & rhs ) const {
			return cmp( lhs, rhs ) > 0;
		}
		bool ge ( const CalculationVector & lhs, const CalculationVector & rhs ) const {
			return cmp( lhs, rhs ) >= 0;
		}
		bool ls ( const CalculationVector & lhs, const CalculationVector & rhs ) const {
			return cmp( lhs, rhs ) < 0;
		}
		bool le ( const CalculationVector & lhs, const CalculationVector & rhs ) const {
			return cmp( lhs, rhs ) >= 0;
		}
	};
}

#endif // __DD_SORT_CRITERIA__
