/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "dd.h"

#include "DDSingleSetRayGenerator.h"
#include "DDDualSetRayGenerator.h"

int main ( int argc, const char** argv ) {

    DD_OUTPUT("***********************************************************************************" )
    DD_OUTPUT("* Addibit: Another Double Description Implementation with BInary Trees.           *" )
    DD_OUTPUT("* Copyright (C) 2013  Blagoy Genov                                                *" )
    DD_OUTPUT("* This program comes with ABSOLUTELY NO WARRANTY!!!                               *" )
    DD_OUTPUT("***********************************************************************************\n" )

	if ( argc < 2 || strncmp( argv[1], "--help", 6 ) == 0 || strncmp( argv[1], "-help", 5 ) == 0 || strncmp( argv[1], "-h", 2 ) == 0 ) {
		DD_OUTPUT( "Usage: addibit MATRIX_FILE [CONFIGURATION_FILE]" );
		return -1;
	}

    if ( argc > 2 ) {
        if ( !Options::current().readSettingsFile( argv[2] ) ) {
            DD_OUTPUT( "Error: The configuration file either doesn't exist or is corrupt!" );
            return -1;
        }
    }

    if ( Options::current().adjacency_test() == PARTITIONED_SETS_TEST ) {
        return generate<DualSetRayGenerator>( argv[1] );
    } else {
        return generate<SingleSetRayGenerator>( argv[1] );
    }
}
