
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cstdlib> 
#include <iostream>

std::vector<long> getRandoms( unsigned long count, long start, long end, bool unique ){
    std::vector<long> randoms;
    unsigned long generated = 0;
    long dist;

    if ( start < 0 && end > 0 ) {
        dist = abs(start) + end;
    } else {
        dist = abs(end - start);
    }

    while ( generated < count ) {
        long current = (rand() % dist) + start;
        if ( !unique || std::find( randoms.begin(), randoms.end(), current ) == randoms.end() ){
            randoms.push_back( current );
            generated++;
        }
    }

	return randoms;
}

std::vector<std::vector<long> > getInitialMatrix( unsigned long dim ) {
    std::vector<std::vector<long> > matrix;

    for ( unsigned long i = 0; i < dim; i++ ) {
        std::vector<long> row( dim );

        for ( unsigned long j = 0; j <= i; j++ ) {
            row[j] = 1;
			std::cout << row[j] << " ";
        }

   /*     row[i] = 1;
		std::cout << row[i] << " ";  */

        for ( unsigned long j = i+1; j < dim; j++ ) {
            row[j] = 0;
			std::cout << row[j] << " ";
        }
        matrix.push_back( row );
		std::cout << std::endl;
    }

    return matrix;
}

int main ( int argc, const char** argv ) {

    srand(time(0));

    unsigned long rows = atoi( argv[1]);
    unsigned long dim = atoi( argv[2]);
	unsigned long count = atoi( argv[3]);
	unsigned long index_diff = atoi( argv[4] );               

	std::cout << rows << " " << dim << std::endl;

    std::vector<std::vector<long> > matrix = getInitialMatrix( dim );

	std::vector<long> row_index = getRandoms( count, 0, dim, true );
	std::vector<long> row_index_prev;

    for ( unsigned long r = dim; r < rows; r++ ) {
        std::vector<long> coeffs = getRandoms( count, -1, 1, false );
		std::vector<long> row( dim, 0 );

        for ( unsigned long i = 0; i < dim; i++ ) {
			if ( std::find( row_index.begin(), row_index.end(), i ) != row_index.end() ) {
				row[i] = 1;
			}
        }

		if ( std::find( matrix.begin(), matrix.end(), row ) == matrix.end() ) {
			matrix.push_back( row );
			for ( unsigned long i = 0; i < row.size(); i++ ) {
				std::cout << row[i] << " ";
			} 
			std::cout << std::endl;
		} else {
			r--;
			row_index = row_index_prev;
			continue;
		}

		row_index_prev = row_index;

		for ( unsigned int i = 0; i < index_diff; i++ ) {
			long new_index = rand() % dim;

			if ( std::find( row_index.begin(), row_index.end(), new_index ) == row_index.end() ) {
				row_index.push_back( new_index );
			} else {
				i--;
			}
		}

		row_index.erase( row_index.begin(), row_index.begin() + index_diff );
    }

	return 0;
}
